//storage fail
/*
try{
    if (typeof storage === 'undefined') var storage = sessionStorage;
} catch {
    error("scripts err");
}*/


$(document).ready(function () {

    /*TOC - links*/
    var tochtml = "<div id='toc-list' class='list-group'>";
    $("h2[data-toc='true']").each(function (index) {
        $(this).attr("id", "toc-item-" + index);
        tochtml += "<a class='list-group-item' href='#toc-item-" + index + "'>" + $(this).text() + "</a>";
    });
    $(".toc-widget-list").html(tochtml + "</div>");
    /*TOC - show*/
    $(".toc-widget-sub").on("click", function () {
        $(this).toggleClass("open");
    })
    /*TOC - jump*/
    $("#toc-list a").on("click", function () {
        var targetobj = $($(this).attr('href'))
        var scrolloffset = targetobj.offset().top - $(window).scrollTop();
        var menuoffset = 102;
        if (scrolloffset > 0) menuoffset -= 60;

        $('html, body').animate({
            scrollTop: targetobj.offset().top - menuoffset
        }, 1000);
    });
    $("body").scrollspy({ target: "#toc-list", offset: 122 })


    /*font size*/
    $(".i-zoom-plus").on("click", function (e) {
        e.stopPropagation();
        changeFontSize("plus");
    });
    $(".i-zoom-minus").on("click", function (e) {
        e.stopPropagation();
        changeFontSize("minus");
    });
    $(".i-zoom-default").on("click", function (e) {
        e.stopPropagation();
        changeFontSize("0");
    });
    $(".i-font").on("click", function () {
        $("body").toggleClass("opendsylexic");
        if ($("body").hasClass("opendsylexic")) {
            saveSetting('dsylexic', "on");
        }else{
            saveSetting('dsylexic', "off");
        }
    });
    $(".i-contrast").on("click", function () {
        $("body").toggleClass("contrast");
        if ($("body").hasClass("contrast")) {
            saveSetting('contrast', "on");
        }else{
            saveSetting('contrast', "off");
        }
    });



    /* sticky breadcrumbs & TOC */
    var $obj = $(".skbreadcrumb");
    var $tocobj = $(".toc-widget");
    if ( $obj.length || $tocobj.length ) {

        var $topmenu = $(".topnavrow");
        if ( $obj.length ) var top = $obj.offset().top - parseFloat($obj.css('marginTop').replace(/auto/, 0));
        if ( $tocobj.length ) var toctop = $tocobj.offset().top;

        $(window).scroll(function (event) {
            // what the y position of the scroll is
            var y = $(this).scrollTop();
            var menuoffset = 60 + parseInt($topmenu.css('top'), 10);
            if ((y + menuoffset) >= top) {
                $obj.addClass('skbreadcrumb-fix');
            } else {
                $obj.removeClass('skbreadcrumb-fix');
            }

            /* toc */
            if ( y + 60 >= toctop ) {
                $tocobj.addClass("toc-widget-fix");
            } else {
                $tocobj.removeClass("toc-widget-fix");
            }

        });
    }

    //top menu 2nd level
    $(".main-navigation-dropdown > ul > li a").on("click", function(e){
        if( $(this).attr("href") == "#" ) e.preventDefault();
        if ( $(this).closest("ul.sksubmenu").length ) {

        }else{
            $(this).parent("li").toggleClass("active").siblings("li").removeClass("active");
        }
    });
    //menu show
    $(".nav-icon-menu").on("click", function (e) {
        e.preventDefault();
        $(this).closest(".main-navigation").toggleClass("show");
    })
    //mobile menu
    $(".mainnav-mob-toggler").on("click", function () {
        $(this).toggleClass("show");
        $(".skmenu-mainnav").toggleClass("hiddenImp");
    })

    /* external links check */
    $("main a[target!=_blank][href^=http]").attr("target", "_blank");

    /*photo carousel - autonumber */
    var photoCarousel = $(".carousel.slide.photo");
    if ( photoCarousel.length ) {
        $(photoCarousel).each(function(i){
            var items = $(this).find(".carousel-item .carousel-caption small");
            $(items).each(function (j) {
                var totalphoto = items.length;
                if ( !$(this).has("span").length ) {
                    $(this).html( $(this).html() + " <span>("+(j+1)+"/"+totalphoto+")</span>");
                }
            });

        });
    }

    //carousel - autonumber
    if($("body").hasClass("german")) var LangSpec = "DE";
    if($("body").hasClass("latin")) var LangSpec = "LA";
    if($("body").hasClass("italian") || $("body").hasClass("italian5")) var LangSpec = "IT";

    var zadaci = $(".carousel.quiz-carousel");
    var alphabet = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.split('');
    var alphaidx = 0;
    const arrows = "<div data-slide='prev'></div><div data-slide='next'></div>";
  
    if (LangSpec == "IT" || LangSpec == "LA") {

        zadaci.each(function (i) {
            var countitem = $(this).find(".carousel-item").length;

            if (countitem > 1) {
                var multiitem = $(this).find(".quiz-carousel.zadatak h3");
                $(multiitem).each(function (j) {
                    var totalitem = multiitem.length;
                    $(this).html($(this).html() + " <span>(" + (j + 1) + "/" + totalitem + ")</span>" + arrows);
                });
                //def arrows remove
                $(this).find("a.carousel-control-prev, a.carousel-control-next").remove();
            }
        });  
    }
  
    if (LangSpec == "DE") {
        var zadaci = $(".carousel.quiz-carousel").not(".ponavljanje-provjera .carousel.quiz-carousel");
        var zadaciponavljanje = $(".ponavljanje-provjera .carousel.quiz-carousel");

        //if zadaci.length
        zadaci.each(function(i){
        var countitem = $(this).find(".carousel-item").length;
    
        if (countitem == 1) {
            $(this).find(".quiz-carousel.zadatak h3").html("Aufgabe " + alphabet[alphaidx]);
            alphaidx++;
        }else{
            var multiitem = $(this).find(".quiz-carousel.zadatak h3");
            var multiTitle = "Aufgabengruppe " + alphabet[alphaidx];
            $(multiitem).each(function (j) {
                var totalitem = multiitem.length;
                $(this).html( multiTitle + " <span>("+(j+1)+"/"+totalitem+")</span>" + arrows);
            });
            alphaidx++;
            //def arrows remove
            $(this).find("a.carousel-control-prev, a.carousel-control-next").remove();
        }
        });
        zadaciponavljanje.each(function(i){
            var multiitem = $(this).find(".quiz-carousel.zadatak h3");
            var multiTitle = "Aufgabe ";
            $(multiitem).each(function (j) {
                var totalitem = multiitem.length;
                $(this).html( multiTitle + " <span>("+(j+1)+"/"+totalitem+")</span>" + arrows);
            });
        });
}


  
    $('div[data-slide="prev"]').click(function() {
      $(this).closest(".carousel.quiz-carousel").carousel('prev');
    });
  
    $('div[data-slide="next"]').click(function() {
      $(this).closest(".carousel.quiz-carousel").carousel('next');
    });
  

    //keyboard
    if ($("body").hasClass("italian") || $("body").hasClass("italian5") || $("body").hasClass("german")) {
        $('.german .zadatak input[type="text"]').keyboard(DEkey);
        $('.italian .zadatak input[type="text"]').keyboard(ITkey);
        $('.italian5 .zadatak input[type="text"]').keyboard(ITkey);
    }



    //video player
    var videoOptions = { language: 'de', nativeTextTracks: false, /*fluid: true,*/ aspectRatio: "4:3", controlBar: { volumePanel: {inline: false}, CurrentTimeDisplay: true }, DurationDisplay: true, bigPlayButton: true };
    var audioOptions = { language: 'de', controlBar: { fullscreenToggle: false }, bigPlayButton: false }
    if ($("body").hasClass("german")) videojs.addLanguage("de", playerDE);
    if ($("body").hasClass("italian") || $("body").hasClass("italian5")) { videoOptions.language = "it"; audioOptions.language="it"; videojs.addLanguage("it", playerIT); }

    $("video").each(function(idx){

      $(this).addClass("video-js").attr("id", "vidplayer"+idx);
      $(this).append("<source src='"+$(this).attr("src")+"' type='"+$(this).attr("type")+"'>");
      var player = videojs("vidplayer"+idx, videoOptions);

      if ($(this).data("sub-id")) {
        var captions = $("#"+$(this).data("sub-id")).html();
        player.ready(function () {
          var VTTParser = new WebVTTParser();
          var parsed = VTTParser.parse(captions);
          var track = player.addTextTrack('captions', 'untertitel', 'hr');
          parsed.cues.forEach(function (cue) {
            var ct = new VTTCue(cue.startTime, cue.endTime, cue.text)
            track.addCue(ct);
          });

         track.mode = 'showing';
       });
      }
    });

    $("audio").each(function (idx) {
      $(this).addClass("video-js audio").attr("id", "audioplayer" + idx);
      var player = videojs("audioplayer" + idx, audioOptions);
    });


//end document ready
});



/*change font */
var selectedSize;
if ( readSetting("fontCustom") != "on" ) {
    changeFontSize("default");
}else { 
    selectedSize = readSetting("fontSize")-1;
    changeFontSize("plus");
}


/*photosmart*/
document.addEventListener('DOMContentLoaded', function () {
    new SmartPhoto(".js-smartphoto", {
        nav: false
    });
});


function changeFontSize(action) {

    var targetClass = ["font-m2", "font-m1", "font-0", "font-p1", "font-p2"];

    switch (action) {
        case "plus":
            selectedSize++;
            if (selectedSize > (targetClass.length - 1)) selectedSize = (targetClass.length - 1);
            saveSetting("fontCustom", "on");
            break;
        case "minus":
            selectedSize--;
            if (selectedSize < 0) selectedSize = 0;
            saveSetting("fontCustom", "on");
            break;
        default:
            selectedSize = Math.floor(targetClass.length/2);
            saveSetting("fontCustom", "off");
    }
    $("html").removeClass().addClass(targetClass[selectedSize]);
    $(".font-size-bar > div").css("width", 100*selectedSize/(targetClass.length-1) + "%");

    saveSetting("fontSize", selectedSize);
}

function saveSetting(key, value){
    try {
        storage.setItem(key, value);
    }
    catch (err) {
        setCookie(key, value, 1);
    }
}
function readSetting(key){
    try {
        return storage.getItem(key);
    }
    catch (err) {
        return getCookie(key);
    }
}
function setCookie(cname, cvalue, exdays) {
    var d = new Date();
    d.setTime(d.getTime() + (exdays*24*60*60*1000));
    var expires = "expires="+ d.toUTCString();
    //document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
    document.cookie = cname + "=" + cvalue + ";path=/";
}
function getCookie(cname) {
    var name = cname + "=";
    var decodedCookie = decodeURIComponent(document.cookie);
    var ca = decodedCookie.split(';');
    for(var i = 0; i <ca.length; i++) {
      var c = ca[i];
      while (c.charAt(0) == ' ') {
        c = c.substring(1);
      }
      if (c.indexOf(name) == 0) {
        return c.substring(name.length, c.length);
      }
    }
    return "";
}



/*menu scroll hide*/
var didScroll;
var lastScrollTop = 0;
var delta = 5;
var navbarHeight = $(".topnavrow").outerHeight();

$(window).scroll(function (event) {
    didScroll = true;
});

setInterval(function () {
    if (didScroll) {
        hasScrolled();
        didScroll = false;
    }
}, 250);

function hasScrolled() {
    var st = $(this).scrollTop();

    // Make sure they scroll more than delta
    if (Math.abs(lastScrollTop - st) <= delta)
        return;

    if (st > lastScrollTop && st > navbarHeight) {
        // Scroll Down
        $(".topnavrow").removeClass("nav-down").addClass("nav-up");
        $(".skbreadcrumb").removeClass("bread-down");
        $(".main-navigation, .skmenu-settings, .skmenu-settings > .dropdown-menu").removeClass("show");
        $(".main-navigation li.active").removeClass("active");
    } else {
        // Scroll Up
        if (st + $(window).height() < $(document).height()) {
            $(".topnavrow").removeClass("nav-up").addClass("nav-down");
            $(".skbreadcrumb").addClass("bread-down");
        }
    }

    lastScrollTop = st;
}


/*actvate*/
if ($(".carousel.naslovnica-modula").length) SetEquiHeight($(".carousel.naslovnica-modula"));

/*function carousel*/
function SetEquiHeight(obj) {
    var carMaxHeight = 0;
    var items = obj.find(".carousel-item");
    $(items).each(function (j) {
        if ($(this).outerHeight() > carMaxHeight) { carMaxHeight = $(this).outerHeight(); }
    });
    $(items).css('height', carMaxHeight + 'px');
}


$(".jsToggle").on("click", function () {
    $(this).toggleClass("show");
    target = $(this).data("target");
    $(target).slideToggle("fast");
})

$(".jsShowAll").on("click", function () {
    var parentDiv = $(this).parent("div");
    parentDiv.siblings("div").show();
    parentDiv.hide("fast");
})

/*zadaci - height - worddrag, target <li>*/
var liEqualObj = $(".odgovor.li-equal-height");
if ( liEqualObj.length ) {
    $(liEqualObj).each(function(i){
        var liMaxHeight = 0;
        var items = $(this).find("li");
        $(items).each(function (j) {
            if ($(this).outerHeight() > liMaxHeight) { liMaxHeight = $(this).outerHeight(); }
        });
        $(items).css('height', liMaxHeight + 'px');
    });
}



/* DE keyboard settings*/
var DEkey = {
    language: ['de'],

    // *** choose layout & positioning ***
    layout: 'custom',
    customLayout: {
      'normal': [
        'ä ö ü ß Ä Ö Ü {a}'
      ]
    },
    position: {
      // null = attach to input/textarea;
      // use $(sel) to attach elsewhere
      of: null,
      my: 'center top',
      at: 'center top',
      // used when "usePreview" is false
      at2: 'center bottom'
    },

    usePreview: false,
    // if true, keyboard will not close if you press escape.
    ignoreEsc: true,
    autoAccept: true,
    autoAcceptOnEsc: false,
    tabNavigation: true,
    enterNavigation: true,
    
    display: {
      // check mark (accept)
      'a': '\u2716:Close'
    },

    css : {
      // input & preview
      input          : '',
      // keyboard container
      container      : 'onscreen-keyboard ui-helper-clearfix',
      // keyboard container extra class (same as container, but separate)
      popup: '',
      // default state
      buttonDefault  : 'ui-state-default',
    }

  }

/* DE video player translations */
const playerDE = {
    "Play": "Wiedergabe",
    "Pause": "Pause",
    "Replay": "Erneut abspielen",
    "Current Time": "Aktueller Zeitpunkt",
    "Duration": "Dauer",
    "Remaining Time": "Verbleibende Zeit",
    "Stream Type": "Streamtyp",
    "LIVE": "LIVE",
    "Loaded": "Geladen",
    "Progress": "Status",
    "Fullscreen": "Vollbild",
    "Non-Fullscreen": "Kein Vollbild",
    "Mute": "Ton aus",
    "Unmute": "Ton ein",
    "Playback Rate": "Wiedergabegeschwindigkeit",
    "Subtitles": "Untertitel",
    "subtitles off": "Untertitel aus",
    "Captions": "Untertitel",
    "captions off": "Untertitel aus",
    "Chapters": "Kapitel",
    "Play Video": "Video abspielen",
    "Close": "Schließen" 
}

/* IT */
var ITkey = {
    language: ['it'],

    // *** choose layout & positioning ***
    layout: 'custom',
    customLayout: {
      'normal': [
        'à è é ì ò ó ù À È É Ì Ò Ó Ù {a}'
      ]
    },
    position: {
      // null = attach to input/textarea;
      // use $(sel) to attach elsewhere
      of: null,
      my: 'center top',
      at: 'center top',
      // used when "usePreview" is false
      at2: 'center bottom'
    },

    usePreview: false,
    // if true, keyboard will not close if you press escape.
    ignoreEsc: true,
    autoAccept: true,
    autoAcceptOnEsc: false,
    tabNavigation: true,
    enterNavigation: true,
    
    display: {
      // check mark (accept)
      'a': '\u2716:Close'
    },

    css : {
      // input & preview
      input          : '',
      // keyboard container
      container      : 'onscreen-keyboard ui-helper-clearfix',
      // keyboard container extra class (same as container, but separate)
      popup: '',
      // default state
      buttonDefault  : 'ui-state-default',
    }

  }

/* IT video player translations */
const playerIT = {
    "Play": "Riproduci",
    "Pause": "Pausa",
    "Current Time": "Orario attuale",
    "Duration": "Durata",
    "Remaining Time": "Tempo rimanente",
    "Stream Type": "Tipo del Streaming",
    "LIVE": "LIVE",
    "Loaded": "Caricato",
    "Progress": "Stato",
    "Fullscreen": "Schermo intero",
    "Non-Fullscreen": "Chiudi schermo intero",
    "Mute": "Muto",
    "Unmute": "Audio",
    "Playback Rate": "Tasso di riproduzione",
    "Subtitles": "Sottotitoli",
    "subtitles off": "Senza sottotitoli",
    "Captions": "Sottotitoli non udenti",
    "captions off": "Senza sottotitoli non udenti",
    "Chapters": "Capitolo"
  }